import java.util.Scanner;

class Vettore {

	public static void main(String[] args) {

		if (args.length == 0) 
			System.err.println("Occorre passare la lunghezza del vettore come argomento all'avvio.");
		else {
			int[] vettore = new int[Integer.parseInt(args[0])];

			Scanner tastiera = new Scanner(System.in);
		
			System.out.println("Inserimento degli interi che compongono il vettore...");
			for (int i = 0; i < vettore.length; i++) {
				System.out.print("Inserire l'intero in posizione " + (i+1) +": ");
				vettore[i] = tastiera.nextInt();
			} 
			
			ruotaTerne(vettore);
			//ruotaTerne1(vettore);
			//ruotaTerne2(vettore);
			//ruotaTerne3(vettore);
			//ruotaTerne4(vettore);
			
			System.out.println("\nVettore dopo la rotazione delle terne:");
			for (int i = 0; i < vettore.length; i++)
				System.out.println("Elemento " + (i+1) +": " + vettore[i]);
		}
	}
	
	// soluzione consigliata
	public static void ruotaTerne(int[] v) {
		int tmp;
		
		for (int i = 2; i < v.length; i=i+3) {
			tmp = v[i];
			v[i] = v[i-1];
			v[i-1] = v[i-2];
			v[i-2] = tmp;
		}
	}

	// soluzione alternativa (con la variabile del for che parte da zero)
	public static void ruotaTerne1(int[] v) {
		int tmp;
		int maxLength = v.length-(v.length%3);
		
		for (int i = 0; i < maxLength; i=i+3) {
			tmp = v[i];
			v[i] = v[i+2];
			v[i+2] = v[i+1];
			v[i+1] = tmp;
		}
	}

	// soluzione alternativa (con tre variabili temporanee)
	public static void ruotaTerne2(int[] v) {
		int tmp1, tmp2, tmp3;
		
		for (int i = 0; i < v.length/3; i++){
			tmp1 = v[i*3];
			tmp2 = v[i*3+1];
			tmp3 = v[i*3+2];
			v[i*3] = tmp3;
			v[i*3+1] = tmp1;
			v[i*3+2] = tmp2;
		}
	}

	// soluzione alternativa (con due cicli for)
	public static void ruotaTerne3(int[] v) {
	
		int daRuotare = v.length-v.length%3;
		
		for (int a = 0; a < daRuotare; a+=3) {
			int last = v[a+2];
			for (int i = a+1; i >= a; i--){
				v[i+1] = v[i];
			}
			v[a] = last;
		}
	}

	// soluzione alternativa (con l'uso di un vettore di supporto)
	public static void ruotaTerne4(int[] v) {
		
		int divisioneVettore = v.length/3;
		int[] nuovoVettore = new int[divisioneVettore*3];
		
		for (int i = 0; i < divisioneVettore; i++) {
			nuovoVettore[i*3] = v[2+i*3];
			nuovoVettore[1+i*3] = v[i*3];
			nuovoVettore[2+i*3] = v[1+i*3];
		}
		
		for (int i = 0; i < nuovoVettore.length; i++)
			v[i] = nuovoVettore[i];
	}
	
	/*public static void stampa (int[] v) {
		for (int i = 0; i < v.length; i++)
			System.out.print(v[i] + " ");
		System.out.print("\n");
	}*/

}

